Index: projects/DailyDrillingReport_1.2/XML/PDFreport/ddr_PDFReport_transformation_2011_03_09.xsl
===================================================================
--- projects/DailyDrillingReport_1.2/XML/PDFreport/ddr_PDFReport_transformation_2011_03_09.xsl (revision 213)
+++ projects/DailyDrillingReport_1.2/XML/PDFreport/ddr_PDFReport_transformation_2011_03_09.xsl (revision 221)
@@ -57,5 +57,5 @@
 									<fo:table-cell vertical-align="middle" horisontal-align="right">
 										<fo:block font-weight="bold" text-align="right" font-size="11pt">End time:
-													<xsl:value-of select="concat(substring-before(substring(/witsml:drillReports/witsml:drillReport/witsml:dTimEnd, 0,17), 'T'), ' ', substring-after(substring(/witsml:drillReports/witsml:drillReport/witsml:dTimEnd, 0,17), 'T'))"/>
+											<xsl:value-of select="concat(substring-before(substring(/witsml:drillReports/witsml:drillReport/witsml:dTimEnd, 0,17), 'T'), ' ', substring-after(substring(/witsml:drillReports/witsml:drillReport/witsml:dTimEnd, 0,17), 'T'))"/>
 										</fo:block>
 									</fo:table-cell>
@@ -140,4 +140,22 @@
 							<xsl:value-of select="$element_drillReportStatusInfo//xsd:element[@name='tvdCsgLast']/@sawsdl:modelReference"/>
 						</xsl:variable>
+						<xsl:variable name="url_waterDepth">
+							<xsl:value-of select="$element_drillReportStatusInfo//xsd:element[@name='waterDepth']/@sawsdl:modelReference"/>
+						</xsl:variable>
+						<xsl:variable name="url_tightWell">
+							<xsl:value-of select="$element_drillReportStatusInfo//xsd:element[@name='tightWell']/@sawsdl:modelReference"/>
+						</xsl:variable>
+						<xsl:variable name="url_hpht">
+							<xsl:value-of select="$element_drillReportStatusInfo//xsd:element[@name='hpht']/@sawsdl:modelReference"/>
+						</xsl:variable>
+						<xsl:variable name="url_avgPresBH">
+							<xsl:value-of select="$element_drillReportStatusInfo//xsd:element[@name='avgPresBH']/@sawsdl:modelReference"/>
+						</xsl:variable>
+						<xsl:variable name="url_expTempBH">
+							<xsl:value-of select="$element_drillReportStatusInfo//xsd:element[@name='expTempBH']/@sawsdl:modelReference"/>
+						</xsl:variable>
+						<xsl:variable name="url_fixedRig">
+							<xsl:value-of select="$element_drillReportStatusInfo//xsd:element[@name='fixedRig']/@sawsdl:modelReference"/>
+						</xsl:variable>
 						<fo:table table-layout="fixed" width="100%" border-collapse="collapse">
 							<fo:table-column column-width="proportional-column-width(20)" column-number="1"/>
@@ -164,5 +182,5 @@
 									<fo:table-cell vertical-align="middle">
 										<fo:block>
-												<xsl:value-of select="concat(substring-before(substring(/witsml:drillReports/witsml:drillReport/witsml:dTimStart, 0,17), 'T'), ' ', 
+											<xsl:value-of select="concat(substring-before(substring(/witsml:drillReports/witsml:drillReport/witsml:dTimStart, 0,17), 'T'), ' ', 
 												substring-after(substring(/witsml:drillReports/witsml:drillReport/witsml:dTimStart, 0,17), 'T'), ' - ', 
 												substring-before(substring(/witsml:drillReports/witsml:drillReport/witsml:dTimEnd, 0,17), 'T'), ' ', 
@@ -318,5 +336,7 @@
 								<fo:table-row>
 									<fo:table-cell vertical-align="middle">
-										<fo:block font-weight="bold">Elevation RKB-MSL <xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:statusInfo/witsml:elevKelly/@uom)">
+										<fo:block font-weight="bold">
+											<fo:basic-link external-destination="url({$url_elevKelly})">Elevation RKB-MSL</fo:basic-link>
+											<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:statusInfo/witsml:elevKelly/@uom)">
 												<fo:inline font-weight="bold">
 													<xsl:value-of select="/witsml:drillReports/witsml:drillReport/witsml:statusInfo/witsml:elevKelly/@uom"/>
@@ -334,5 +354,7 @@
 									</fo:table-cell>
 									<fo:table-cell vertical-align="middle">
-										<fo:block font-size="11pt" font-weight="bold">Water depth MSL <xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:statusInfo/witsml:waterDepth/@uom)">
+										<fo:block font-size="11pt" font-weight="bold">
+											<fo:basic-link external-destination="url({$url_waterDepth})">Water depth MSL </fo:basic-link>
+											<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:statusInfo/witsml:waterDepth/@uom)">
 												<fo:inline>
 													<xsl:value-of select="/witsml:drillReports/witsml:drillReport/witsml:statusInfo/witsml:waterDepth/@uom"/>
@@ -353,5 +375,5 @@
 									<fo:table-cell vertical-align="middle">
 										<fo:block font-weight="bold">
-											<fo:basic-link external-destination="url({$urlRDS})" font-weight="bold">Tight well</fo:basic-link>: </fo:block>
+											<fo:basic-link external-destination="url({$url_tightWell})" font-weight="bold">Tight well</fo:basic-link>: </fo:block>
 									</fo:table-cell>
 									<fo:table-cell vertical-align="middle">
@@ -363,5 +385,5 @@
 									<fo:table-cell vertical-align="middle">
 										<fo:block font-size="11pt" font-weight="bold">
-											<fo:basic-link external-destination="url({$urlRDS})" font-weight="bold">High pressure - High temperature</fo:basic-link>  </fo:block>
+											<fo:basic-link external-destination="url({$url_hpht})" font-weight="bold">High pressure - High temperature</fo:basic-link>  </fo:block>
 									</fo:table-cell>
 									<fo:table-cell vertical-align="middle">
@@ -375,5 +397,5 @@
 									<fo:table-cell vertical-align="middle">
 										<fo:block font-weight="bold">
-											<fo:basic-link external-destination="url({$urlRDS})">Pressure </fo:basic-link>
+											<fo:basic-link external-destination="url({$url_avgPresBH})">Pressure </fo:basic-link>
 											<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:statusInfo/witsml:avgPresBH/@uom)">
 												<fo:inline>
@@ -393,5 +415,5 @@
 									<fo:table-cell vertical-align="middle">
 										<fo:block font-size="11pt" font-weight="bold">
-											<fo:basic-link external-destination="url({$urlRDS})">Temperature </fo:basic-link>
+											<fo:basic-link external-destination="url({$url_expTempBH})">Temperature </fo:basic-link>
 											<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:statusInfo/witsml:expTempBH/@uom)">
 												<fo:inline>
@@ -412,5 +434,7 @@
 								<fo:table-row>
 									<fo:table-cell vertical-align="middle">
-										<fo:block font-weight="bold">Fixed rig</fo:block>
+										<fo:block font-weight="bold">
+											<fo:basic-link external-destination="url({$url_fixedRig})">Fixed rig</fo:basic-link>
+										</fo:block>
 									</fo:table-cell>
 									<fo:table-cell vertical-align="middle">
@@ -1107,4 +1131,28 @@
 							<xsl:variable name="url_manufacturer">
 								<xsl:value-of select="$element_bitRecord//xsd:element[@name='manufacturer']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_eTimOpBit">
+								<xsl:value-of select="$element_bitRecord/bitRun//xsd:element[@name='eTimOpBit']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_mdHoleStart">
+								<xsl:value-of select="$element_bitRecord/bitRun//xsd:element[@name='mdHoleStart']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_mdHoleStop">
+								<xsl:value-of select="$element_bitRecord/bitRun//xsd:element[@name='mdHoleStop']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_ropAv">
+								<xsl:value-of select="$element_bitRecord/bitRun//xsd:element[@name='ropAv']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_mdTotHoleMade">
+								<xsl:value-of select="$element_bitRecord/bitRun//xsd:element[@name='mdTotHoleMade']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_totHrsDrilled">
+								<xsl:value-of select="$element_bitRecord/bitRun//xsd:element[@name='totHrsDrilled']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_totRop">
+								<xsl:value-of select="$element_bitRecord/bitRun//xsd:element[@name='totRop']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_dullGrade">
+								<xsl:value-of select="$element_bitRecord/bitRun//xsd:element[@name='dullGrade']/@sawsdl:modelReference"/>
 							</xsl:variable>
 							<fo:table width="100%">
@@ -1171,5 +1219,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Hours drilled</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_eTimOpBit})">Hours drilled</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:eTimOpBit/@uom)">
@@ -1181,5 +1231,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>MD Start</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_mdHoleStart})">MD Start</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:mdHoleStart/@uom)">
@@ -1191,5 +1243,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>MD end</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_mdHoleStop})">MD end</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:mdHoleStop/@uom)">
@@ -1201,5 +1255,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Hole made (run)</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_mdHoleStop})">Hole made (last 24H)</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:mdHoleStop/@uom)">
@@ -1211,15 +1267,12 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Hours drilled (run)</fo:block>
-																<fo:block>
-																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:mdHoleStop/@uom)">
-																		<fo:inline>
-																			<xsl:value-of select="/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:mdHoleStop/@uom"/>
-																		</fo:inline>
-																	</xsl:if>
-																</fo:block>
-															</fo:table-cell>
-															<fo:table-cell>
-																<fo:block>ROP</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_eTimOpBit})">Hours drilled (last 24H)</fo:basic-link>
+																</fo:block>
+															</fo:table-cell>
+															<fo:table-cell>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_ropAv})">ROP</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:ropAv/@uom)">
@@ -1231,5 +1284,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Total hole made</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_mdTotHoleMade})">Total hole made</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:mdTotHoleMade/@uom)">
@@ -1241,5 +1296,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Total hours drilled</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_totHrsDrilled})">Total hours drilled</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:totHrsDrilled/@uom)">
@@ -1251,9 +1308,11 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Total ROP</fo:block>
-																<fo:block>
-																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:ropMx/@uom)">
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_totRop})">Total ROP</fo:basic-link>
+																</fo:block>
+																<fo:block>
+																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:totRop/@uom)">
 																		<fo:inline>
-																			<xsl:value-of select="/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:ropMx/@uom"/>
+																			<xsl:value-of select="/witsml:drillReports/witsml:drillReport/witsml:bitRecord/witsml:bitRun/witsml:totRop/@uom"/>
 																		</fo:inline>
 																	</xsl:if>
@@ -1261,5 +1320,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Dull grade</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_dullGrade})">Dull grade</fo:basic-link>
+																</fo:block>
 															</fo:table-cell>
 														</fo:table-row>
@@ -1376,7 +1437,7 @@
 																<fo:table-cell>
 																	<fo:block>
-																		<xsl:if test="string(witsml:bitRun/witsml:ropMx)">
-																			<fo:inline>
-																				<xsl:value-of select="witsml:bitRun/witsml:ropMx"/>
+																		<xsl:if test="string(witsml:bitRun/witsml:totRop)">
+																			<fo:inline>
+																				<xsl:value-of select="witsml:bitRun/witsml:totRop"/>
 																			</fo:inline>
 																		</xsl:if>
@@ -1406,4 +1467,44 @@
 					<xsl:if test="count(/witsml:drillReports/witsml:drillReport/witsml:casing_liner_tubing) &gt; 0">
 						<fo:block>
+							<xsl:variable name="element_pipe" select="document($ddrSchema)/xsd:schema/xsd:complexType[@name='casing_liner_tubing']/xsd:sequence"/>
+							<xsl:variable name="url_type">
+								<xsl:value-of select="$element_pipe//xsd:element[@name='type']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_casingType">
+								<xsl:value-of select="$element_pipe/casing_liner_tubing_run//xsd:element[@name='casingType']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_dTimStart">
+								<xsl:value-of select="$element_pipe/casing_liner_tubing_run//xsd:element[@name='dTimStart']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_dTimEnd">
+								<xsl:value-of select="$element_pipe/casing_liner_tubing_run//xsd:element[@name='dTimEnd']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_od">
+								<xsl:value-of select="$element_pipe//xsd:element[@name='od']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_id">
+								<xsl:value-of select="$element_pipe//xsd:element[@name='id']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_weight">
+								<xsl:value-of select="$element_pipe//xsd:element[@name='weight']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_grade">
+								<xsl:value-of select="$element_pipe//xsd:element[@name='grade']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_connection">
+								<xsl:value-of select="$element_pipe//xsd:element[@name='connection']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_length">
+								<xsl:value-of select="$element_pipe//xsd:element[@name='length']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_mdTop">
+								<xsl:value-of select="$element_pipe//xsd:element[@name='mdTop']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_mdBottom">
+								<xsl:value-of select="$element_pipe//xsd:element[@name='mdBottom']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_description">
+								<xsl:value-of select="$element_pipe/casing_liner_tubing_run//xsd:element[@name='description']/@sawsdl:modelReference"/>
+							</xsl:variable>
 							<fo:leader rule-thickness="2px" leader-length="100%" leader-pattern="rule"/>
 							<fo:leader/>
@@ -1442,14 +1543,22 @@
 														<fo:table-row font-weight="bold">
 															<fo:table-cell>
-																<fo:block>Type of pipe</fo:block>
-															</fo:table-cell>
-															<fo:table-cell>
-																<fo:block>Casing type</fo:block>
-															</fo:table-cell>
-															<fo:table-cell>
-																<fo:block>Run time</fo:block>
-															</fo:table-cell>
-															<fo:table-cell>
-																<fo:block>Nominal outside diameter</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_type})">Type of pipe</fo:basic-link>
+																</fo:block>
+															</fo:table-cell>
+															<fo:table-cell>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_casingType})">Casing type</fo:basic-link>
+																</fo:block>
+															</fo:table-cell>
+															<fo:table-cell>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_dTimStart})">Run time</fo:basic-link>
+																</fo:block>
+															</fo:table-cell>
+															<fo:table-cell>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_od})">Nominal outside diameter</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:casing_liner_tubing/witsml:od/@uom)">
@@ -1461,5 +1570,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Nominal inside diameter</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_id})">Nominal inside diameter</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:casing_liner_tubing/witsml:id/@uom)">
@@ -1471,5 +1582,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Nominal Weight</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_weight})">Nominal Weight</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:casing_liner_tubing/witsml:weight/@uom)">
@@ -1481,11 +1594,17 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>Nominal Grade</fo:block>
-															</fo:table-cell>
-															<fo:table-cell>
-																<fo:block>Nominal Connection</fo:block>
-															</fo:table-cell>
-															<fo:table-cell>
-																<fo:block>Length</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_grade})">Nominal Grade</fo:basic-link>
+																</fo:block>
+															</fo:table-cell>
+															<fo:table-cell>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_connection})">Nominal Connection</fo:basic-link>
+																</fo:block>
+															</fo:table-cell>
+															<fo:table-cell>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_length})">Length</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:casing_liner_tubing/witsml:mdTop/@uom)">
@@ -1497,5 +1616,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>MD Top/Hangar</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_mdTop})">MD Top/Hangar</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:casing_liner_tubing/witsml:mdTop/@uom)">
@@ -1507,5 +1628,7 @@
 															</fo:table-cell>
 															<fo:table-cell>
-																<fo:block>MD Bottom/Shoe</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_mdBottom})">MD Bottom/Shoe</fo:basic-link>
+																</fo:block>
 																<fo:block>
 																	<xsl:if test="string(/witsml:drillReports/witsml:drillReport/witsml:casing_liner_tubing/witsml:mdBottom/@uom)">
@@ -1517,5 +1640,7 @@
 															</fo:table-cell>
 															<fo:table-cell  text-align="left">
-																<fo:block>Description</fo:block>
+																<fo:block>
+																	<fo:basic-link external-destination="url({$url_description})">Description</fo:basic-link>
+																</fo:block>
 															</fo:table-cell>
 														</fo:table-row>
@@ -1544,7 +1669,7 @@
 																<fo:table-cell>
 																	<fo:block>
-																		<xsl:if test="string(substring-after(substring(witsml:casing_liner_tubing_run/witsml:dTimEnd, 0, 17), 'T'))">
-																			<fo:inline>
-																				<xsl:value-of select="substring-after(substring(witsml:casing_liner_tubing_run/witsml:dTimEnd, 0, 17), 'T')"/>
+																		<xsl:if test="string(substring-after(substring(witsml:casing_liner_tubing_run/witsml:dTimStart, 0, 17), 'T'))">
+																			<fo:inline>
+																				<xsl:value-of select="substring-after(substring(witsml:casing_liner_tubing_run/witsml:dTimStart, 0, 17), 'T')"/>
 																			</fo:inline>
 																		</xsl:if>
@@ -1645,4 +1770,50 @@
 					<xsl:if test="count(/witsml:drillReports/witsml:drillReport/witsml:cementStage) &gt; 0">
 						<fo:block break-before="page">
+							<xsl:variable name="element_cement" select="document($ddrSchema)/xsd:schema/xsd:complexType[@name='cs_cementStage']/xsd:sequence"/>
+							<xsl:variable name="url_dTimPumpStart">
+								<xsl:value-of select="$element_cement//xsd:element[@name='dTimPumpStart']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_dTimPumpEnd">
+								<xsl:value-of select="$element_cement//xsd:element[@name='dTimPumpEnd']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_jobType">
+								<xsl:value-of select="$element_cement//xsd:element[@name='jobType']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_casingStrDia">
+								<xsl:value-of select="$element_cement//xsd:element[@name='casingStrDia']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_topPlug">
+								<xsl:value-of select="$element_cement//xsd:element[@name='topPlug']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_botPlug">
+								<xsl:value-of select="$element_cement//xsd:element[@name='botPlug']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_plugBumped">
+								<xsl:value-of select="$element_cement//xsd:element[@name='plugBumped']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_presBump">
+								<xsl:value-of select="$element_cement//xsd:element[@name='presBump']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_floatHeld">
+								<xsl:value-of select="$element_cement//xsd:element[@name='floatHeld']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_eTimPresHeld">
+								<xsl:value-of select="$element_cement//xsd:element[@name='eTimPresHeld']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_annFlowAfter">
+								<xsl:value-of select="$element_cement//xsd:element[@name='annFlowAfter']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_volReturns">
+								<xsl:value-of select="$element_cement//xsd:element[@name='volReturns']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_reciprocated">
+								<xsl:value-of select="$element_cement//xsd:element[@name='reciprocated']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_rotated">
+								<xsl:value-of select="$element_cement//xsd:element[@name='rotated']/@sawsdl:modelReference"/>
+							</xsl:variable>
+							<xsl:variable name="url_comments">
+								<xsl:value-of select="$element_cement//xsd:element[@name='comments']/@sawsdl:modelReference"/>
+							</xsl:variable>
 							<xsl:for-each select="/witsml:drillReports/witsml:drillReport/witsml:cementStage">
 								<fo:block>
@@ -1686,14 +1857,22 @@
 																<fo:table-row font-weight="bold">
 																	<fo:table-cell>
-																		<fo:block>Start time</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>End time</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Job type</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Casing string diameter</fo:block>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_dTimPumpStart})">Start time</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_dTimPumpEnd})">End time</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_jobType})">Job type</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_casingStrDia})">Casing string diameter</fo:basic-link>
+																		</fo:block>
 																		<fo:block>
 																			<xsl:if test="string(witsml:casingStrDia/@uom)">
@@ -1705,14 +1884,22 @@
 																	</fo:table-cell>
 																	<fo:table-cell>
-																		<fo:block>Top plug used</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Bottom plug used</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Plug bumped</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Plug bump pressure</fo:block>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_topPlug})">Top plug used</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_botPlug})">Bottom plug used</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_plugBumped})">Plug bumped</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_presBump})">Plug bump pressure</fo:basic-link>
+																		</fo:block>
 																		<fo:block>
 																			<xsl:if test="string(witsml:presBump/@uom)">
@@ -1724,14 +1911,22 @@
 																	</fo:table-cell>
 																	<fo:table-cell>
-																		<fo:block>Float held</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Pressure release time</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Full returns</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Cement volume returns</fo:block>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_floatHeld})">Float held</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_eTimPresHeld})">Pressure release time</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_annFlowAfter})">Full returns</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_volReturns})">Cement volume returns</fo:basic-link>
+																		</fo:block>
 																		<fo:block>
 																			<xsl:if test="string(witsml:volReturns/@uom)">
@@ -1743,11 +1938,17 @@
 																	</fo:table-cell>
 																	<fo:table-cell>
-																		<fo:block>Reciprocated</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Rotated</fo:block>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_reciprocated})">Reciprocated</fo:basic-link>
+																		</fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_rotated})">Rotated</fo:basic-link>
+																		</fo:block>
 																	</fo:table-cell>
 																	<fo:table-cell  text-align="left">
-																		<fo:block>Comments</fo:block>
+																		<fo:block>
+																			<fo:basic-link external-destination="url({$url_comments})">Comments</fo:basic-link>
+																		</fo:block>
 																	</fo:table-cell>
 																</fo:table-row>
@@ -1891,4 +2092,32 @@
 											</fo:table-row>
 											<fo:table-row>
+												<xsl:variable name="element_cementingFluid" select="document($ddrSchema)/xsd:schema/xsd:complexType[@name='cementingFluid']/xsd:sequence"/>
+												<xsl:variable name="url_typeFluid">
+													<xsl:value-of select="$element_cementingFluid//xsd:element[@name='mudClass']/@sawsdl:modelReference"/>
+												</xsl:variable>
+												<xsl:variable name="url_descFluid">
+													<xsl:value-of select="$element_cementingFluid//xsd:element[@name='descFluid']/@sawsdl:modelReference"/>
+												</xsl:variable>
+												<xsl:variable name="url_density">
+													<xsl:value-of select="$element_cementingFluid//xsd:element[@name='density']/@sawsdl:modelReference"/>
+												</xsl:variable>
+												<xsl:variable name="url_volPumped">
+													<xsl:value-of select="$element_cementingFluid//xsd:element[@name='volPumped']/@sawsdl:modelReference"/>
+												</xsl:variable>
+												<xsl:variable name="url_yp">
+													<xsl:value-of select="$element_cementingFluid//xsd:element[@name='yp']/@sawsdl:modelReference"/>
+												</xsl:variable>
+												<xsl:variable name="url_ratioMixWater">
+													<xsl:value-of select="$element_cementingFluid//xsd:element[@name='ratioMixWater']/@sawsdl:modelReference"/>
+												</xsl:variable>
+												<xsl:variable name="url_pcFreeWater">
+													<xsl:value-of select="$element_cementingFluid//xsd:element[@name='pcFreeWater']/@sawsdl:modelReference"/>
+												</xsl:variable>
+												<xsl:variable name="url_eTimThickening">
+													<xsl:value-of select="$element_cementingFluid//xsd:element[@name='eTimThickening']/@sawsdl:modelReference"/>
+												</xsl:variable>
+												<xsl:variable name="url_comments">
+													<xsl:value-of select="$element_cementingFluid//xsd:element[@name='comments']/@sawsdl:modelReference"/>
+												</xsl:variable>
 												<fo:table-cell>
 													<fo:block>
@@ -1906,8 +2135,10 @@
 																<fo:table-row font-weight="bold">
 																	<fo:table-cell>
-																		<fo:block>Fluid type</fo:block>
-																	</fo:table-cell>
-																	<fo:table-cell>
-																		<fo:block>Volume pumped</fo:block>
+																		<fo:block>
+																		<fo:basic-link external-destination="url({$url_typeFluid})">Fluid type</fo:basic-link></fo:block>
+																	</fo:table-cell>
+																	<fo:table-cell>
+																		<fo:block>
+																		<fo:basic-link external-destination="url({$url_volPumped})">Volume pumped</fo:basic-link></fo:block>
 																		<fo:block>
 																			<xsl:if test="string(witsml:cementingFluid/witsml:volPumped/@uom)">
@@ -1919,5 +2150,6 @@
 																	</fo:table-cell>
 																	<fo:table-cell>
-																		<fo:block>Fluid densitiy</fo:block>
+																		<fo:block>
+																		<fo:basic-link external-destination="url({$url_density})">Fluid densitiy</fo:basic-link></fo:block>
 																		<fo:block>
 																			<xsl:if test="string(witsml:cementingFluid/witsml:density/@uom)">
@@ -1929,5 +2161,6 @@
 																	</fo:table-cell>
 																	<fo:table-cell>
-																		<fo:block>Yield point</fo:block>
+																		<fo:block>
+																		<fo:basic-link external-destination="url({$url_yp})">Yield point</fo:basic-link></fo:block>
 																		<fo:block>
 																			<xsl:if test="string(witsml:cementingFluid/witsml:yp/@uom)">
@@ -1939,5 +2172,6 @@
 																	</fo:table-cell>
 																	<fo:table-cell>
-																		<fo:block>Mix water ratio</fo:block>
+																		<fo:block>
+																		<fo:basic-link external-destination="url({$url_ratioMixWater})">Mix water ratio</fo:basic-link></fo:block>
 																		<fo:block>
 																			<xsl:if test="string(witsml:cementingFluid/witsml:ratioMixWater/@uom)">
@@ -1949,5 +2183,6 @@
 																	</fo:table-cell>
 																	<fo:table-cell>
-																		<fo:block>Free water</fo:block>
+																		<fo:block>
+																		<fo:basic-link external-destination="url({$url_pcFreeWater})">Free water</fo:basic-link></fo:block>
 																		<fo:block>
 																			<xsl:if test="string(witsml:cementingFluid/witsml:pcFreeWater/@uom)">
@@ -1959,5 +2194,6 @@
 																	</fo:table-cell>
 																	<fo:table-cell>
-																		<fo:block>Thick time</fo:block>
+																		<fo:block>
+																		<fo:basic-link external-destination="url({$url_eTimThickening})">Thickening time</fo:basic-link></fo:block>
 																		<fo:block>
 																			<xsl:if test="string(witsml:cementingFluid/witsml:eTimThickening/@uom)">
@@ -1969,8 +2205,10 @@
 																	</fo:table-cell>
 																	<fo:table-cell text-align="left">
-																		<fo:block>Fluid Description</fo:block>
+																		<fo:block>
+																		<fo:basic-link external-destination="url({$url_descFluid})">Fluid Description</fo:basic-link></fo:block>
 																	</fo:table-cell>
 																	<fo:table-cell  text-align="left">
-																		<fo:block>Comments</fo:block>
+																		<fo:block>
+																		<fo:basic-link external-destination="url({$url_comments})">Comments</fo:basic-link></fo:block>
 																	</fo:table-cell>
 																</fo:table-row>
